diff -urN ../VisualBoyAdvance-20061204/src/GBA.cpp src/GBA.cpp
--- ../VisualBoyAdvance-20061204/src/GBA.cpp	2006-08-25 23:13:38 +0900
+++ src/GBA.cpp	2006-12-05 00:18:42 +0900
@@ -23,6 +23,7 @@
 #include <string.h>
 
 #include "GBA.h"
+#include "GBAcpu.h"
 #include "GBAinline.h"
 #include "Globals.h"
 #include "Gfx.h"
@@ -42,29 +43,6 @@
 #include "prof/prof.h"
 #endif
 
-#define UPDATE_REG(address, value)\
-  {\
-    WRITE16LE(((u16 *)&ioMem[address]),value);\
-  }\
-
-#define ARM_PREFETCH \
-  {\
-    cpuPrefetch[0] = CPUReadMemoryQuick(armNextPC);\
-    cpuPrefetch[1] = CPUReadMemoryQuick(armNextPC+4);\
-  }
-
-#define THUMB_PREFETCH \
-  {\
-    cpuPrefetch[0] = CPUReadHalfWordQuick(armNextPC);\
-    cpuPrefetch[1] = CPUReadHalfWordQuick(armNextPC+2);\
-  }
-
-#define ARM_PREFETCH_NEXT \
-  cpuPrefetch[1] = CPUReadMemoryQuick(armNextPC+4);
-
-#define THUMB_PREFETCH_NEXT\
-  cpuPrefetch[1] = CPUReadHalfWordQuick(armNextPC+2);
-
 #ifdef __GNUC__
 #define _stricmp strcasecmp
 #endif
@@ -513,210 +491,6 @@
 #endif
 
 
-// Waitstates when accessing data
-inline int dataTicksAccess16(u32 address) // DATA 8/16bits NON SEQ
-{
-  int addr = (address>>24)&15;
-  int value =  memoryWait[addr];
-
-  if ((addr>=0x08) || (addr < 0x02))
-  {
-    busPrefetchCount=0;
-    busPrefetch=false;
-  }
-  else if (busPrefetch)
-  {
-    int waitState = value;
-    if (!waitState)
-      waitState = 1;
-    busPrefetchCount = ((++busPrefetchCount)<<waitState) - 1;
-  }
-
-  return value;
-}
-
-inline int dataTicksAccess32(u32 address) // DATA 32bits NON SEQ
-{
-  int addr = (address>>24)&15;
-  int value = memoryWait32[addr];
-
-  if ((addr>=0x08) || (addr < 0x02))
-  {
-    busPrefetchCount=0;
-    busPrefetch=false;
-  }
-  else if (busPrefetch)
-  {
-    int waitState = value;
-    if (!waitState)
-      waitState = 1;
-    busPrefetchCount = ((++busPrefetchCount)<<waitState) - 1;
-  }
-
-  return value;
-}
-
-inline int dataTicksAccessSeq16(u32 address)// DATA 8/16bits SEQ
-{
-  int addr = (address>>24)&15;
-  int value = memoryWaitSeq[addr];
-
-  if ((addr>=0x08) || (addr < 0x02))
-  {
-    busPrefetchCount=0;
-    busPrefetch=false;
-  }
-  else if (busPrefetch)
-  {
-    int waitState = value;
-    if (!waitState)
-      waitState = 1;
-    busPrefetchCount = ((++busPrefetchCount)<<waitState) - 1;
-  }
-
-  return value;
-}
-
-inline int dataTicksAccessSeq32(u32 address)// DATA 32bits SEQ
-{
-  int addr = (address>>24)&15;
-  int value =  memoryWaitSeq32[addr];
-
-  if ((addr>=0x08) || (addr < 0x02))
-  {
-    busPrefetchCount=0;
-    busPrefetch=false;
-  }
-  else if (busPrefetch)
-  {
-    int waitState = value;
-    if (!waitState)
-      waitState = 1;
-    busPrefetchCount = ((++busPrefetchCount)<<waitState) - 1;
-  }
-
-  return value;
-}
-
-
-// Waitstates when executing opcode
-inline int codeTicksAccess16(u32 address) // THUMB NON SEQ
-{
-  int addr = (address>>24)&15;
-
-  if ((addr>=0x08) && (addr<=0x0D))
-  {
-    if (busPrefetchCount&0x1)
-    {
-      if (busPrefetchCount&0x2)
-      {
-        busPrefetchCount = ((busPrefetchCount&0xFF)>>2) | (busPrefetchCount&0xFFFFFF00);
-        return 0;
-      }
-      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
-      return memoryWaitSeq[addr]-1;
-    }
-    else
-    {
-      busPrefetchCount=0;
-      return memoryWait[addr];
-    }
-  }
-  else
-  {
-    busPrefetchCount = 0;
-    return memoryWait[addr];
-  }
-}
-
-inline int codeTicksAccess32(u32 address) // ARM NON SEQ
-{
-  int addr = (address>>24)&15;
-
-  if ((addr>=0x08) && (addr<=0x0D))
-  {
-    if (busPrefetchCount&0x1)
-    {
-      if (busPrefetchCount&0x2)
-      {
-        busPrefetchCount = ((busPrefetchCount&0xFF)>>2) | (busPrefetchCount&0xFFFFFF00);
-        return 0;
-      }
-      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
-      return memoryWaitSeq[addr] - 1;
-    }
-    else
-    {
-      busPrefetchCount = 0;
-      return memoryWait32[addr];
-    }
-  }
-  else
-  {
-    busPrefetchCount = 0;
-    return memoryWait32[addr];
-  }
-}
-
-inline int codeTicksAccessSeq16(u32 address) // THUMB SEQ
-{
-  int addr = (address>>24)&15;
-
-  if ((addr>=0x08) && (addr<=0x0D))
-  {
-    if (busPrefetchCount&0x1)
-    {
-      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
-      return 0;
-    }
-    else
-    if (busPrefetchCount>0xFF)
-    {
-      busPrefetchCount=0;
-      return memoryWait[addr];
-    }
-    else
-      return memoryWaitSeq[addr];
-  }
-  else
-  {
-    busPrefetchCount = 0;
-    return memoryWaitSeq[addr];
-  }
-}
-
-inline int codeTicksAccessSeq32(u32 address) // ARM SEQ
-{
-  int addr = (address>>24)&15;
-
-  if ((addr>=0x08) && (addr<=0x0D))
-  {
-    if (busPrefetchCount&0x1)
-    {
-      if (busPrefetchCount&0x2)
-      {
-        busPrefetchCount = ((busPrefetchCount&0xFF)>>2) | (busPrefetchCount&0xFFFFFF00);
-        return 0;
-      }
-      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
-      return memoryWaitSeq[addr];
-    }
-    else
-    if (busPrefetchCount>0xFF)
-    {
-      busPrefetchCount=0;
-      return memoryWait32[addr];
-    }
-    else
-      return memoryWaitSeq32[addr];
-  }
-  else
-  {
-    return memoryWaitSeq32[addr];
-  }
-}
-
-
 inline int CPUUpdateTicks()
 {
   int cpuLoopTicks = lcdTicks;
@@ -3127,249 +2901,6 @@
   timerOnOffDelay = 0;
 }
 
-void CPUWriteHalfWord(u32 address, u16 value)
-{
-#ifdef DEV_VERSION
-  if(address & 1) {
-    if(systemVerbose & VERBOSE_UNALIGNED_MEMORY) {
-      log("Unaligned halfword write: %04x to %08x from %08x\n",
-          value,
-          address,
-          armMode ? armNextPC - 4 : armNextPC - 2);
-    }
-  }
-#endif
-  
-  switch(address >> 24) {
-  case 2:
-#ifdef BKPT_SUPPORT
-    if(*((u16 *)&freezeWorkRAM[address & 0x3FFFE]))
-      cheatsWriteHalfWord(address & 0x203FFFE,
-                          value);
-    else
-#endif
-      WRITE16LE(((u16 *)&workRAM[address & 0x3FFFE]),value);
-    break;
-  case 3:
-#ifdef BKPT_SUPPORT
-    if(*((u16 *)&freezeInternalRAM[address & 0x7ffe]))
-      cheatsWriteHalfWord(address & 0x3007ffe,
-                          value);
-    else
-#endif
-      WRITE16LE(((u16 *)&internalRAM[address & 0x7ffe]), value);
-    break;    
-  case 4:
-    if(address < 0x4000400)
-      CPUUpdateRegister(address & 0x3fe, value);
-    else goto unwritable;
-    break;
-  case 5:
-#ifdef BKPT_SUPPORT
-    if(*((u16 *)&freezePRAM[address & 0x03fe]))
-      cheatsWriteHalfWord(address & 0x70003fe,
-                          value);
-    else
-#endif
-    WRITE16LE(((u16 *)&paletteRAM[address & 0x3fe]), value);
-    break;
-  case 6:
-    address = (address & 0x1fffe);
-    if (((DISPCNT & 7) >2) && ((address & 0x1C000) == 0x18000))
-        return;
-    if ((address & 0x18000) == 0x18000)
-      address &= 0x17fff;
-#ifdef BKPT_SUPPORT
-    if(*((u16 *)&freezeVRAM[address]))
-      cheatsWriteHalfWord(address + 0x06000000,
-                          value);
-    else
-#endif
-    WRITE16LE(((u16 *)&vram[address]), value); 
-    break;
-  case 7:
-#ifdef BKPT_SUPPORT
-    if(*((u16 *)&freezeOAM[address & 0x03fe]))
-      cheatsWriteHalfWord(address & 0x70003fe,
-                          value);
-    else
-#endif
-    WRITE16LE(((u16 *)&oam[address & 0x3fe]), value);
-    break;
-  case 8:
-  case 9:
-    if(address == 0x80000c4 || address == 0x80000c6 || address == 0x80000c8) {
-      if(!rtcWrite(address, value))
-        goto unwritable;
-    } else if(!agbPrintWrite(address, value)) goto unwritable;
-    break;
-  case 13:
-    if(cpuEEPROMEnabled) {
-      eepromWrite(address, (u8)value);
-      break;
-    }
-    goto unwritable;
-  case 14:
-    if(!eepromInUse | cpuSramEnabled | cpuFlashEnabled) {
-      (*cpuSaveGameFunc)(address, (u8)value);
-      break;
-    }
-    goto unwritable;
-  default:
-  unwritable:
-#ifdef DEV_VERSION
-    if(systemVerbose & VERBOSE_ILLEGAL_WRITE) {
-      log("Illegal halfword write: %04x to %08x from %08x\n",
-          value,
-          address,
-          armMode ? armNextPC - 4 : armNextPC - 2);
-    }
-#endif
-    break;
-  }
-}
-
-void CPUWriteByte(u32 address, u8 b)
-{
-  switch(address >> 24) {
-  case 2:
-#ifdef BKPT_SUPPORT
-      if(freezeWorkRAM[address & 0x3FFFF])
-        cheatsWriteByte(address & 0x203FFFF, b);
-      else
-#endif  
-        workRAM[address & 0x3FFFF] = b;
-    break;
-  case 3:
-#ifdef BKPT_SUPPORT
-    if(freezeInternalRAM[address & 0x7fff])
-      cheatsWriteByte(address & 0x3007fff, b);
-    else
-#endif
-      internalRAM[address & 0x7fff] = b;
-    break;
-  case 4:
-    if(address < 0x4000400) {
-      switch(address & 0x3FF) {
-      case 0x301:
-	if(b == 0x80)
-	  stopState = true;
-	holdState = 1;
-	holdType = -1;
-  cpuNextEvent = cpuTotalTicks;
-	break;
-      case 0x60:
-      case 0x61:
-      case 0x62:
-      case 0x63:
-      case 0x64:
-      case 0x65:
-      case 0x68:
-      case 0x69:
-      case 0x6c:
-      case 0x6d:
-      case 0x70:
-      case 0x71:
-      case 0x72:
-      case 0x73:
-      case 0x74:
-      case 0x75:
-      case 0x78:
-      case 0x79:
-      case 0x7c:
-      case 0x7d:
-      case 0x80:
-      case 0x81:
-      case 0x84:
-      case 0x85:
-      case 0x90:
-      case 0x91:
-      case 0x92:
-      case 0x93:
-      case 0x94:
-      case 0x95:
-      case 0x96:
-      case 0x97:
-      case 0x98:
-      case 0x99:
-      case 0x9a:
-      case 0x9b:
-      case 0x9c:
-      case 0x9d:
-      case 0x9e:
-      case 0x9f:      
-	soundEvent(address&0xFF, b);
-	break;
-      default:
-	if(address & 1)
-	  CPUUpdateRegister(address & 0x3fe,
-			    ((READ16LE(((u16 *)&ioMem[address & 0x3fe])))
-			     & 0x00FF) |
-			    b<<8);
-	else
-	  CPUUpdateRegister(address & 0x3fe,
-			    ((READ16LE(((u16 *)&ioMem[address & 0x3fe])) & 0xFF00) | b));
-      }
-      break;
-    } else goto unwritable;
-    break;
-  case 5:
-    // no need to switch
-    *((u16 *)&paletteRAM[address & 0x3FE]) = (b << 8) | b;
-    break;
-  case 6:
-    address = (address & 0x1fffe);
-    if (((DISPCNT & 7) >2) && ((address & 0x1C000) == 0x18000))
-        return;
-    if ((address & 0x18000) == 0x18000)
-      address &= 0x17fff;
-
-    // no need to switch 
-    // byte writes to OBJ VRAM are ignored
-    if ((address) < objTilesAddress[((DISPCNT&7)+1)>>2])
-    {
-#ifdef BKPT_SUPPORT
-      if(freezeVRAM[address])
-        cheatsWriteByte(address + 0x06000000, b);
-      else
-#endif  
-            *((u16 *)&vram[address]) = (b << 8) | b;
-    }
-    break;
-  case 7:
-    // no need to switch
-    // byte writes to OAM are ignored
-    //    *((u16 *)&oam[address & 0x3FE]) = (b << 8) | b;
-    break;    
-  case 13:
-    if(cpuEEPROMEnabled) {
-      eepromWrite(address, b);
-      break;
-    }
-    goto unwritable;
-  case 14:
-      if (!(saveType == 5) && (!eepromInUse | cpuSramEnabled | cpuFlashEnabled)) {
-
-    //if(!cpuEEPROMEnabled && (cpuSramEnabled | cpuFlashEnabled)) { 
-
-        (*cpuSaveGameFunc)(address, b);
-      break;
-    }
-    // default
-  default:
-  unwritable:
-#ifdef DEV_VERSION
-    if(systemVerbose & VERBOSE_ILLEGAL_WRITE) {
-      log("Illegal byte write: %02x to %08x from %08x\n",
-          b,
-          address,
-          armMode ? armNextPC - 4 : armNextPC -2 );
-    }
-#endif
-    break;
-  }
-}
-
 u8 cpuBitsSet[256];
 u8 cpuLowestBitSet[256];
 
@@ -3865,25 +3396,14 @@
 #endif /* FINAL_VERSION */
 
     if(!holdState && !SWITicks) {
-
-      // Emulates the Cheat System (m) code
-      if((cheatsEnabled) && (mastercode) && (mastercode == armNextPC))
-      {
-        u32 joy = 0;
-        if(systemReadJoypads())
-          joy = systemReadJoypad(-1);
-        u32 ext = (joy >> 10);
-        cpuTotalTicks += cheatsCheckKeys(P1^0x3FF, ext);
-      }
-
-      if ((armNextPC & 0x0803FFFF) == 0x08020000)
-        busPrefetchCount=0x100;
-
       if(armState) {
-#include "arm-new.h"
+        if (!armExecute())
+          return;
       } else {
-#include "thumb.h"
+        if (!thumbExecute())
+          return;
       }
+      clockTicks = 0;
     } else
       clockTicks = CPUUpdateTicks();
 
diff -urN ../VisualBoyAdvance-20061204/src/GBA.h src/GBA.h
--- ../VisualBoyAdvance-20061204/src/GBA.h	2006-08-25 23:13:38 +0900
+++ src/GBA.h	2006-12-05 00:15:16 +0900
@@ -113,8 +113,6 @@
 extern void doMirroring(bool);
 extern void CPUUpdateRegister(u32, u16);
 extern void applyTimer ();
-extern void CPUWriteHalfWord(u32, u16);
-extern void CPUWriteByte(u32, u8);
 extern void CPUInit(const char *,bool);
 extern void CPUReset();
 extern void CPULoop(int);
diff -urN ../VisualBoyAdvance-20061204/src/GBAcpu.h src/GBAcpu.h
--- ../VisualBoyAdvance-20061204/src/GBAcpu.h	1970-01-01 09:00:00 +0900
+++ src/GBAcpu.h	2006-12-05 00:18:42 +0900
@@ -0,0 +1,302 @@
+// -*- C++ -*-
+// VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
+// Copyright (C) 1999-2003 Forgotten
+// Copyright (C) 2005 Forgotten and the VBA development team
+
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; either version 2, or(at your option)
+// any later version.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this program; if not, write to the Free Software Foundation,
+// Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+#ifndef VBA_GBAcpu_H
+#define VBA_GBAcpu_H
+
+extern int armExecute();
+extern int thumbExecute();
+
+#ifdef __GNUC__
+# define INSN_REGPARM __attribute__((regparm(1)))
+# define LIKELY(x) __builtin_expect(!!(x),1)
+# define UNLIKELY(x) __builtin_expect(!!(x),0)
+#else
+# define INSN_REGPARM /*nothing*/
+# define LIKELY(x) (x)
+# define UNLIKELY(x) (x)
+#endif
+
+#define UPDATE_REG(address, value)\
+  {\
+    WRITE16LE(((u16 *)&ioMem[address]),value);\
+  }\
+
+#define ARM_PREFETCH \
+  {\
+    cpuPrefetch[0] = CPUReadMemoryQuick(armNextPC);\
+    cpuPrefetch[1] = CPUReadMemoryQuick(armNextPC+4);\
+  }
+
+#define THUMB_PREFETCH \
+  {\
+    cpuPrefetch[0] = CPUReadHalfWordQuick(armNextPC);\
+    cpuPrefetch[1] = CPUReadHalfWordQuick(armNextPC+2);\
+  }
+
+#define ARM_PREFETCH_NEXT \
+  cpuPrefetch[1] = CPUReadMemoryQuick(armNextPC+4);
+
+#define THUMB_PREFETCH_NEXT\
+  cpuPrefetch[1] = CPUReadHalfWordQuick(armNextPC+2);
+
+
+extern int SWITicks;
+extern u32 mastercode;
+extern bool busPrefetch;
+extern bool busPrefetchEnable;
+extern u32 busPrefetchCount;
+extern int cpuNextEvent;
+extern bool holdState;
+extern u32 cpuPrefetch[2];
+extern int cpuTotalTicks;
+extern u8 memoryWait[16];
+extern u8 memoryWait32[16];
+extern u8 memoryWaitSeq[16];
+extern u8 memoryWaitSeq32[16];
+extern u8 cpuBitsSet[256];
+extern u8 cpuLowestBitSet[256];
+extern void CPUSwitchMode(int mode, bool saveState, bool breakLoop);
+extern void CPUSwitchMode(int mode, bool saveState);
+extern void CPUUpdateCPSR();
+extern void CPUUpdateFlags(bool breakLoop);
+extern void CPUUpdateFlags();
+extern void CPUUndefinedException();
+extern void CPUSoftwareInterrupt();
+extern void CPUSoftwareInterrupt(int comment);
+
+
+// Waitstates when accessing data
+inline int dataTicksAccess16(u32 address) // DATA 8/16bits NON SEQ
+{
+  int addr = (address>>24)&15;
+  int value =  memoryWait[addr];
+
+  if ((addr>=0x08) || (addr < 0x02))
+  {
+    busPrefetchCount=0;
+    busPrefetch=false;
+  }
+  else if (busPrefetch)
+  {
+    int waitState = value;
+    if (!waitState)
+      waitState = 1;
+    busPrefetchCount = ((busPrefetchCount+1)<<waitState) - 1;
+  }
+
+  return value;
+}
+
+inline int dataTicksAccess32(u32 address) // DATA 32bits NON SEQ
+{
+  int addr = (address>>24)&15;
+  int value = memoryWait32[addr];
+
+  if ((addr>=0x08) || (addr < 0x02))
+  {
+    busPrefetchCount=0;
+    busPrefetch=false;
+  }
+  else if (busPrefetch)
+  {
+    int waitState = value;
+    if (!waitState)
+      waitState = 1;
+    busPrefetchCount = ((busPrefetchCount+1)<<waitState) - 1;
+  }
+
+  return value;
+}
+
+inline int dataTicksAccessSeq16(u32 address)// DATA 8/16bits SEQ
+{
+  int addr = (address>>24)&15;
+  int value = memoryWaitSeq[addr];
+
+  if ((addr>=0x08) || (addr < 0x02))
+  {
+    busPrefetchCount=0;
+    busPrefetch=false;
+  }
+  else if (busPrefetch)
+  {
+    int waitState = value;
+    if (!waitState)
+      waitState = 1;
+    busPrefetchCount = ((busPrefetchCount+1)<<waitState) - 1;
+  }
+
+  return value;
+}
+
+inline int dataTicksAccessSeq32(u32 address)// DATA 32bits SEQ
+{
+  int addr = (address>>24)&15;
+  int value =  memoryWaitSeq32[addr];
+
+  if ((addr>=0x08) || (addr < 0x02))
+  {
+    busPrefetchCount=0;
+    busPrefetch=false;
+  }
+  else if (busPrefetch)
+  {
+    int waitState = value;
+    if (!waitState)
+      waitState = 1;
+    busPrefetchCount = ((busPrefetchCount+1)<<waitState) - 1;
+  }
+
+  return value;
+}
+
+
+// Waitstates when executing opcode
+inline int codeTicksAccess16(u32 address) // THUMB NON SEQ
+{
+  int addr = (address>>24)&15;
+
+  if ((addr>=0x08) && (addr<=0x0D))
+  {
+    if (busPrefetchCount&0x1)
+    {
+      if (busPrefetchCount&0x2)
+      {
+        busPrefetchCount = ((busPrefetchCount&0xFF)>>2) | (busPrefetchCount&0xFFFFFF00);
+        return 0;
+      }
+      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
+      return memoryWaitSeq[addr]-1;
+    }
+    else
+    {
+      busPrefetchCount=0;
+      return memoryWait[addr];
+    }
+  }
+  else
+  {
+    busPrefetchCount = 0;
+    return memoryWait[addr];
+  }
+}
+
+inline int codeTicksAccess32(u32 address) // ARM NON SEQ
+{
+  int addr = (address>>24)&15;
+
+  if ((addr>=0x08) && (addr<=0x0D))
+  {
+    if (busPrefetchCount&0x1)
+    {
+      if (busPrefetchCount&0x2)
+      {
+        busPrefetchCount = ((busPrefetchCount&0xFF)>>2) | (busPrefetchCount&0xFFFFFF00);
+        return 0;
+      }
+      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
+      return memoryWaitSeq[addr] - 1;
+    }
+    else
+    {
+      busPrefetchCount = 0;
+      return memoryWait32[addr];
+    }
+  }
+  else
+  {
+    busPrefetchCount = 0;
+    return memoryWait32[addr];
+  }
+}
+
+inline int codeTicksAccessSeq16(u32 address) // THUMB SEQ
+{
+  int addr = (address>>24)&15;
+
+  if ((addr>=0x08) && (addr<=0x0D))
+  {
+    if (busPrefetchCount&0x1)
+    {
+      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
+      return 0;
+    }
+    else
+    if (busPrefetchCount>0xFF)
+    {
+      busPrefetchCount=0;
+      return memoryWait[addr];
+    }
+    else
+      return memoryWaitSeq[addr];
+  }
+  else
+  {
+    busPrefetchCount = 0;
+    return memoryWaitSeq[addr];
+  }
+}
+
+inline int codeTicksAccessSeq32(u32 address) // ARM SEQ
+{
+  int addr = (address>>24)&15;
+
+  if ((addr>=0x08) && (addr<=0x0D))
+  {
+    if (busPrefetchCount&0x1)
+    {
+      if (busPrefetchCount&0x2)
+      {
+        busPrefetchCount = ((busPrefetchCount&0xFF)>>2) | (busPrefetchCount&0xFFFFFF00);
+        return 0;
+      }
+      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
+      return memoryWaitSeq[addr];
+    }
+    else
+    if (busPrefetchCount>0xFF)
+    {
+      busPrefetchCount=0;
+      return memoryWait32[addr];
+    }
+    else
+      return memoryWaitSeq32[addr];
+  }
+  else
+  {
+    return memoryWaitSeq32[addr];
+  }
+}
+
+
+// Emulates the Cheat System (m) code
+inline void cpuMasterCodeCheck()
+{
+  if((cheatsEnabled) && (mastercode) && (mastercode == armNextPC))
+  {
+    u32 joy = 0;
+    if(systemReadJoypads())
+      joy = systemReadJoypad(-1);
+    u32 ext = (joy >> 10);
+    cpuTotalTicks += cheatsCheckKeys(P1^0x3FF, ext);
+  }
+}
+
+#endif //VBA_GBAcpu_H
diff -urN ../VisualBoyAdvance-20061204/src/GBAinline.h src/GBAinline.h
--- ../VisualBoyAdvance-20061204/src/GBAinline.h	2006-09-04 06:52:25 +0900
+++ src/GBAinline.h	2006-12-05 00:18:42 +0900
@@ -23,7 +23,15 @@
 #include "System.h"
 #include "Port.h"
 #include "RTC.h"
+#include "Sound.h"
+#include "agbprint.h"
 
+extern const u32 objTilesAddress[3];
+
+extern bool stopState;
+extern bool holdState;
+extern int holdType;
+extern int cpuNextEvent;
 extern bool cpuSramEnabled;
 extern bool cpuFlashEnabled;
 extern bool cpuEEPROMEnabled;
@@ -485,4 +493,247 @@
   }
 }
 
+static inline void CPUWriteHalfWord(u32 address, u16 value)
+{
+#ifdef DEV_VERSION
+  if(address & 1) {
+    if(systemVerbose & VERBOSE_UNALIGNED_MEMORY) {
+      log("Unaligned halfword write: %04x to %08x from %08x\n",
+          value,
+          address,
+          armMode ? armNextPC - 4 : armNextPC - 2);
+    }
+  }
+#endif
+  
+  switch(address >> 24) {
+  case 2:
+#ifdef BKPT_SUPPORT
+    if(*((u16 *)&freezeWorkRAM[address & 0x3FFFE]))
+      cheatsWriteHalfWord(address & 0x203FFFE,
+                          value);
+    else
+#endif
+      WRITE16LE(((u16 *)&workRAM[address & 0x3FFFE]),value);
+    break;
+  case 3:
+#ifdef BKPT_SUPPORT
+    if(*((u16 *)&freezeInternalRAM[address & 0x7ffe]))
+      cheatsWriteHalfWord(address & 0x3007ffe,
+                          value);
+    else
+#endif
+      WRITE16LE(((u16 *)&internalRAM[address & 0x7ffe]), value);
+    break;    
+  case 4:
+    if(address < 0x4000400)
+      CPUUpdateRegister(address & 0x3fe, value);
+    else goto unwritable;
+    break;
+  case 5:
+#ifdef BKPT_SUPPORT
+    if(*((u16 *)&freezePRAM[address & 0x03fe]))
+      cheatsWriteHalfWord(address & 0x70003fe,
+                          value);
+    else
+#endif
+    WRITE16LE(((u16 *)&paletteRAM[address & 0x3fe]), value);
+    break;
+  case 6:
+    address = (address & 0x1fffe);
+    if (((DISPCNT & 7) >2) && ((address & 0x1C000) == 0x18000))
+        return;
+    if ((address & 0x18000) == 0x18000)
+      address &= 0x17fff;
+#ifdef BKPT_SUPPORT
+    if(*((u16 *)&freezeVRAM[address]))
+      cheatsWriteHalfWord(address + 0x06000000,
+                          value);
+    else
+#endif
+    WRITE16LE(((u16 *)&vram[address]), value); 
+    break;
+  case 7:
+#ifdef BKPT_SUPPORT
+    if(*((u16 *)&freezeOAM[address & 0x03fe]))
+      cheatsWriteHalfWord(address & 0x70003fe,
+                          value);
+    else
+#endif
+    WRITE16LE(((u16 *)&oam[address & 0x3fe]), value);
+    break;
+  case 8:
+  case 9:
+    if(address == 0x80000c4 || address == 0x80000c6 || address == 0x80000c8) {
+      if(!rtcWrite(address, value))
+        goto unwritable;
+    } else if(!agbPrintWrite(address, value)) goto unwritable;
+    break;
+  case 13:
+    if(cpuEEPROMEnabled) {
+      eepromWrite(address, (u8)value);
+      break;
+    }
+    goto unwritable;
+  case 14:
+    if(!eepromInUse | cpuSramEnabled | cpuFlashEnabled) {
+      (*cpuSaveGameFunc)(address, (u8)value);
+      break;
+    }
+    goto unwritable;
+  default:
+  unwritable:
+#ifdef DEV_VERSION
+    if(systemVerbose & VERBOSE_ILLEGAL_WRITE) {
+      log("Illegal halfword write: %04x to %08x from %08x\n",
+          value,
+          address,
+          armMode ? armNextPC - 4 : armNextPC - 2);
+    }
+#endif
+    break;
+  }
+}
+
+static inline void CPUWriteByte(u32 address, u8 b)
+{
+  switch(address >> 24) {
+  case 2:
+#ifdef BKPT_SUPPORT
+      if(freezeWorkRAM[address & 0x3FFFF])
+        cheatsWriteByte(address & 0x203FFFF, b);
+      else
+#endif  
+        workRAM[address & 0x3FFFF] = b;
+    break;
+  case 3:
+#ifdef BKPT_SUPPORT
+    if(freezeInternalRAM[address & 0x7fff])
+      cheatsWriteByte(address & 0x3007fff, b);
+    else
+#endif
+      internalRAM[address & 0x7fff] = b;
+    break;
+  case 4:
+    if(address < 0x4000400) {
+      switch(address & 0x3FF) {
+      case 0x301:
+	if(b == 0x80)
+	  stopState = true;
+	holdState = 1;
+	holdType = -1;
+  cpuNextEvent = cpuTotalTicks;
+	break;
+      case 0x60:
+      case 0x61:
+      case 0x62:
+      case 0x63:
+      case 0x64:
+      case 0x65:
+      case 0x68:
+      case 0x69:
+      case 0x6c:
+      case 0x6d:
+      case 0x70:
+      case 0x71:
+      case 0x72:
+      case 0x73:
+      case 0x74:
+      case 0x75:
+      case 0x78:
+      case 0x79:
+      case 0x7c:
+      case 0x7d:
+      case 0x80:
+      case 0x81:
+      case 0x84:
+      case 0x85:
+      case 0x90:
+      case 0x91:
+      case 0x92:
+      case 0x93:
+      case 0x94:
+      case 0x95:
+      case 0x96:
+      case 0x97:
+      case 0x98:
+      case 0x99:
+      case 0x9a:
+      case 0x9b:
+      case 0x9c:
+      case 0x9d:
+      case 0x9e:
+      case 0x9f:      
+	soundEvent(address&0xFF, b);
+	break;
+      default:
+	if(address & 1)
+	  CPUUpdateRegister(address & 0x3fe,
+			    ((READ16LE(((u16 *)&ioMem[address & 0x3fe])))
+			     & 0x00FF) |
+			    b<<8);
+	else
+	  CPUUpdateRegister(address & 0x3fe,
+			    ((READ16LE(((u16 *)&ioMem[address & 0x3fe])) & 0xFF00) | b));
+      }
+      break;
+    } else goto unwritable;
+    break;
+  case 5:
+    // no need to switch
+    *((u16 *)&paletteRAM[address & 0x3FE]) = (b << 8) | b;
+    break;
+  case 6:
+    address = (address & 0x1fffe);
+    if (((DISPCNT & 7) >2) && ((address & 0x1C000) == 0x18000))
+        return;
+    if ((address & 0x18000) == 0x18000)
+      address &= 0x17fff;
+
+    // no need to switch 
+    // byte writes to OBJ VRAM are ignored
+    if ((address) < objTilesAddress[((DISPCNT&7)+1)>>2])
+    {
+#ifdef BKPT_SUPPORT
+      if(freezeVRAM[address])
+        cheatsWriteByte(address + 0x06000000, b);
+      else
+#endif  
+            *((u16 *)&vram[address]) = (b << 8) | b;
+    }
+    break;
+  case 7:
+    // no need to switch
+    // byte writes to OAM are ignored
+    //    *((u16 *)&oam[address & 0x3FE]) = (b << 8) | b;
+    break;    
+  case 13:
+    if(cpuEEPROMEnabled) {
+      eepromWrite(address, b);
+      break;
+    }
+    goto unwritable;
+  case 14:
+      if (!(saveType == 5) && (!eepromInUse | cpuSramEnabled | cpuFlashEnabled)) {
+
+    //if(!cpuEEPROMEnabled && (cpuSramEnabled | cpuFlashEnabled)) { 
+
+        (*cpuSaveGameFunc)(address, b);
+      break;
+    }
+    // default
+  default:
+  unwritable:
+#ifdef DEV_VERSION
+    if(systemVerbose & VERBOSE_ILLEGAL_WRITE) {
+      log("Illegal byte write: %02x to %08x from %08x\n",
+          b,
+          address,
+          armMode ? armNextPC - 4 : armNextPC -2 );
+    }
+#endif
+    break;
+  }
+}
+
 #endif //VBA_GBAinline_H
diff -urN ../VisualBoyAdvance-20061204/src/gtk/Makefile.am src/gtk/Makefile.am
--- ../VisualBoyAdvance-20061204/src/gtk/Makefile.am	2004-05-14 07:57:09 +0900
+++ src/gtk/Makefile.am	2006-12-05 00:18:42 +0900
@@ -49,6 +49,9 @@
 	../Flash.h		\
 	../GBA.cpp		\
 	../GBA.h		\
+	../GBA-arm.cpp		\
+	../GBA-thumb.cpp	\
+	../GBAcpu.h		\
 	../GBAinline.h		\
 	../Gfx.cpp		\
 	../Gfx.h		\
@@ -76,7 +79,6 @@
 	../admame.cpp		\
 	../agbprint.cpp		\
 	../agbprint.h		\
-	../arm-new.h		\
 	../armdis.cpp		\
 	../armdis.h		\
 	../bilinear.cpp		\
@@ -99,7 +101,6 @@
 	../remote.cpp		\
 	../scanline.cpp		\
 	../simple2x.cpp		\
-	../thumb.h		\
 	../unzip.cpp		\
 	../unzip.h
 
diff -urN ../VisualBoyAdvance-20061204/src/sdl/Makefile.am src/sdl/Makefile.am
--- ../VisualBoyAdvance-20061204/src/sdl/Makefile.am	2004-05-21 06:01:30 +0900
+++ src/sdl/Makefile.am	2006-12-05 00:18:42 +0900
@@ -16,6 +16,9 @@
 	../Flash.h		\
 	../GBA.cpp		\
 	../GBA.h		\
+	../GBA-arm.cpp		\
+	../GBA-thumb.cpp	\
+	../GBAcpu.h		\
 	../GBAinline.h		\
 	../Gfx.cpp		\
 	../Gfx.h		\
@@ -43,7 +46,6 @@
 	../admame.cpp		\
 	../agbprint.cpp		\
 	../agbprint.h		\
-	../arm-new.h		\
 	../armdis.cpp		\
 	../armdis.h		\
 	../bilinear.cpp		\
@@ -71,7 +73,6 @@
 	../remote.cpp		\
 	../scanline.cpp		\
 	../simple2x.cpp		\
-	../thumb.h		\
 	../unzip.cpp		\
 	../unzip.h
 
@@ -93,6 +94,9 @@
 	../Flash.h		\
 	../GBA.cpp		\
 	../GBA.h		\
+	../GBA-arm.cpp		\
+	../GBA-thumb.cpp	\
+	../GBAcpu.h		\
 	../GBAinline.h		\
 	../Gfx.cpp		\
 	../Gfx.h		\
@@ -120,7 +124,6 @@
 	../admame.cpp		\
 	../agbprint.cpp		\
 	../agbprint.h		\
-	../arm-new.h		\
 	../armdis.cpp		\
 	../armdis.h		\
 	../bios.cpp		\
@@ -143,7 +146,6 @@
 	../remote.cpp		\
 	../scanline.cpp		\
 	../simple2x.cpp		\
-	../thumb.h		\
 	../unzip.cpp		\
 	../unzip.h
 
diff -urN ../VisualBoyAdvance-20061204/win32/GBA.dsp win32/GBA.dsp
--- ../VisualBoyAdvance-20061204/win32/GBA.dsp	2004-11-05 09:51:52 +0900
+++ win32/GBA.dsp	2006-12-05 00:18:42 +0900
@@ -176,6 +176,14 @@
 # End Source File
 # Begin Source File
 
+SOURCE=..\src\GBA-arm.cpp
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\GBA-thumb.cpp
+# End Source File
+# Begin Source File
+
 SOURCE=..\src\Gfx.cpp
 # End Source File
 # Begin Source File
@@ -660,10 +668,6 @@
 # End Source File
 # Begin Source File
 
-SOURCE="..\src\arm-new.h"
-# End Source File
-# Begin Source File
-
 SOURCE=..\src\armdis.h
 # End Source File
 # Begin Source File
@@ -996,10 +1000,6 @@
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\thumb.h
-# End Source File
-# Begin Source File
-
 SOURCE=..\src\win32\TileView.h
 # End Source File
 # Begin Source File
diff -urN ../VisualBoyAdvance-20061204/win32/GBA.vcproj win32/GBA.vcproj
--- ../VisualBoyAdvance-20061204/win32/GBA.vcproj	2004-03-10 06:03:21 +0900
+++ win32/GBA.vcproj	2006-12-05 00:18:42 +0900
@@ -354,6 +354,12 @@
 					RelativePath="..\src\GBA.cpp">
 				</File>
 				<File
+					RelativePath="..\src\GBA-arm.cpp">
+				</File>
+				<File
+					RelativePath="..\src\GBA-thumb.cpp">
+				</File>
+				<File
 					RelativePath="..\src\Gfx.cpp">
 				</File>
 				<File
@@ -842,9 +848,6 @@
 				RelativePath="..\src\agbprint.h">
 			</File>
 			<File
-				RelativePath="..\src\arm-new.h">
-			</File>
-			<File
 				RelativePath="..\src\armdis.h">
 			</File>
 			<File
@@ -896,9 +899,6 @@
 				RelativePath="..\src\win32\stdafx.h">
 			</File>
 			<File
-				RelativePath="..\src\thumb.h">
-			</File>
-			<File
 				RelativePath="..\src\unzip.h">
 			</File>
 		</Filter>
diff -urN ../VisualBoyAdvance-20061204/win32/gba_sdl.dsp win32/gba_sdl.dsp
--- ../VisualBoyAdvance-20061204/win32/gba_sdl.dsp	2004-03-30 07:08:56 +0900
+++ win32/gba_sdl.dsp	2006-12-05 00:18:42 +0900
@@ -141,6 +141,14 @@
 # End Source File
 # Begin Source File
 
+SOURCE=..\src\GBA-arm.cpp
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\GBA-thumb.cpp
+# End Source File
+# Begin Source File
+
 SOURCE=..\src\Gfx.cpp
 # End Source File
 # Begin Source File
diff -urN ../VisualBoyAdvance-20061204/win32/gba_sdl.vcproj win32/gba_sdl.vcproj
--- ../VisualBoyAdvance-20061204/win32/gba_sdl.vcproj	2004-03-30 07:08:56 +0900
+++ win32/gba_sdl.vcproj	2006-12-05 00:18:42 +0900
@@ -147,6 +147,12 @@
 					RelativePath="..\src\GBA.cpp">
 				</File>
 				<File
+					RelativePath="..\src\GBA-arm.cpp">
+				</File>
+				<File
+					RelativePath="..\src\GBA-thumb.cpp">
+				</File>
+				<File
 					RelativePath="..\src\Gfx.cpp">
 				</File>
 				<File
